# Code

## networking
### client
getaddrinfo
connect

!include(client.c lang=c)

### server
listen
accept

!include(accept.c lang=c)

## parallel processing
### fork exec
-> fork siehe server

!include(exec.c lang=c)

#### signal

!include(signal.c lang=c)

### pthread

!include(threadpool.c lang=c)


## jbuffer

!include(jbuffer.c lang=c)

## open File

!include(fopen.c lang=c)

## listfiles

!include(listFiles.c lang=c)


## reading / handling strings
printf formats

!include(getline.c lang=c)

fgets -> sscanf

strncmp

### inputredirection dup2
//TODO

## optional

### sem

!include(sem.c lang=c)

### stroulSave

!include(strtoulSave.c lang=c)

# other
## RAID
* RAID 0 : Daten werden ¨uber mehrere Platten gespeichert
keinerlei Datensicherung: Ausfall einer Platte l¨asst Gesamtsystem ausfallen
* RAID 1 : Daten werden auf zwei Platten gleichzeitig gespeichert
eine Platte kann ausfallen, aber doppelter Speicherbedarf
* RAID 4 : Daten werden ¨uber mehrere Platten gespeichert, eine enthält Parität
Paritätsblock aus byteweisen XOR-Verknüpfungen,
eine Platte kann ausfallen, prinzipiell beliebige Plattenanzahl (ab 3)
Nachteil: Paritätsplatte hoch belastet
* RAID 5 : Paritätsblock wird über alle Platten verstreut
* RAID 6 : doppelte Paritätsblöcke

## deadlock

## fether- / light- / heavy- weight threads/processeses